# Organizations ## Get your Zero Trust organization `client.ZeroTrust.Organizations.List(ctx, query) (*Organization, error)` **get** `/{accounts_or_zones}/{account_or_zone_id}/access/organizations` Returns the configuration for your Zero Trust organization. ### Parameters - `query OrganizationListParams` - `AccountID param.Field[string]` The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `ZoneID param.Field[string]` The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `type Organization struct{…}` - `AllowAuthenticateViaWARP bool` When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AuthDomain string` The unique subdomain assigned to your Zero Trust organization. - `AutoRedirectToIdentity bool` When set to `true`, users skip the identity provider selection step during login. - `CustomPages OrganizationCustomPages` - `Forbidden string` The uid of the custom page to use when a user is denied access after failing a non-identity rule. - `IdentityDenied string` The uid of the custom page to use when a user is denied access. - `DenyUnmatchedRequests bool` Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames []string` Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly bool` Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign LoginDesign` - `BackgroundColor string` The background color on your login page. - `FooterText string` The text at the bottom of your login page. - `HeaderText string` The text at the top of your login page. - `LogoPath string` The URL of the logo on your login page. - `TextColor string` The text color on your login page. - `MfaConfig OrganizationMfaConfig` Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationMfaConfigAllowedAuthenticatorTotp OrganizationMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationMfaConfigAllowedAuthenticatorBiometrics OrganizationMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationMfaConfigAllowedAuthenticatorSecurityKey OrganizationMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps bool` Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `Name string` The name of your Zero Trust organization. - `SessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason string` A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime string` The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) organization, err := client.ZeroTrust.Organizations.List(context.TODO(), zero_trust.OrganizationListParams{ }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", organization.AutoRedirectToIdentity) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "allow_authenticate_via_warp": true, "auth_domain": "test.cloudflareaccess.com", "auto_redirect_to_identity": true, "created_at": "2014-01-01T05:20:00.12345Z", "custom_pages": { "forbidden": "699d98642c564d2e855e9661899b7252", "identity_denied": "699d98642c564d2e855e9661899b7252" }, "deny_unmatched_requests": true, "deny_unmatched_requests_exempted_zone_names": [ "example.com" ], "is_ui_read_only": true, "login_design": { "background_color": "#c5ed1b", "footer_text": "This is an example description.", "header_text": "This is an example description.", "logo_path": "https://example.com/logo.png", "text_color": "#c5ed1b" }, "mfa_config": { "allowed_authenticators": [ "totp", "biometrics", "security_key" ], "session_duration": "24h" }, "mfa_required_for_all_apps": false, "name": "Widget Corps Internal Applications", "session_duration": "24h", "ui_read_only_toggle_reason": "Temporarily turn off the UI read only lock to make a change via the UI", "updated_at": "2014-01-01T05:20:00.12345Z", "user_seat_expiration_inactive_time": "730h", "warp_auth_session_duration": "24h" } } ``` ## Create your Zero Trust organization `client.ZeroTrust.Organizations.New(ctx, params) (*Organization, error)` **post** `/{accounts_or_zones}/{account_or_zone_id}/access/organizations` Sets up a Zero Trust organization for your account or zone. ### Parameters - `params OrganizationNewParams` - `AuthDomain param.Field[string]` Body param: The unique subdomain assigned to your Zero Trust organization. - `Name param.Field[string]` Body param: The name of your Zero Trust organization. - `AccountID param.Field[string]` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `ZoneID param.Field[string]` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `AllowAuthenticateViaWARP param.Field[bool]` Body param: When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AutoRedirectToIdentity param.Field[bool]` Body param: When set to `true`, users skip the identity provider selection step during login. - `DenyUnmatchedRequests param.Field[bool]` Body param: Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames param.Field[[]string]` Body param: Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly param.Field[bool]` Body param: Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign param.Field[LoginDesign]` Body param - `MfaConfig param.Field[OrganizationNewParamsMfaConfig]` Body param: Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationNewParamsMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationNewParamsMfaConfigAllowedAuthenticatorTotp OrganizationNewParamsMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationNewParamsMfaConfigAllowedAuthenticatorBiometrics OrganizationNewParamsMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationNewParamsMfaConfigAllowedAuthenticatorSecurityKey OrganizationNewParamsMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps param.Field[bool]` Body param: Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `SessionDuration param.Field[string]` Body param: The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason param.Field[string]` Body param: A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime param.Field[string]` Body param: The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration param.Field[string]` Body param: The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. ### Returns - `type Organization struct{…}` - `AllowAuthenticateViaWARP bool` When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AuthDomain string` The unique subdomain assigned to your Zero Trust organization. - `AutoRedirectToIdentity bool` When set to `true`, users skip the identity provider selection step during login. - `CustomPages OrganizationCustomPages` - `Forbidden string` The uid of the custom page to use when a user is denied access after failing a non-identity rule. - `IdentityDenied string` The uid of the custom page to use when a user is denied access. - `DenyUnmatchedRequests bool` Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames []string` Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly bool` Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign LoginDesign` - `BackgroundColor string` The background color on your login page. - `FooterText string` The text at the bottom of your login page. - `HeaderText string` The text at the top of your login page. - `LogoPath string` The URL of the logo on your login page. - `TextColor string` The text color on your login page. - `MfaConfig OrganizationMfaConfig` Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationMfaConfigAllowedAuthenticatorTotp OrganizationMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationMfaConfigAllowedAuthenticatorBiometrics OrganizationMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationMfaConfigAllowedAuthenticatorSecurityKey OrganizationMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps bool` Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `Name string` The name of your Zero Trust organization. - `SessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason string` A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime string` The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) organization, err := client.ZeroTrust.Organizations.New(context.TODO(), zero_trust.OrganizationNewParams{ AuthDomain: cloudflare.F("test.cloudflareaccess.com"), Name: cloudflare.F("Widget Corps Internal Applications"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", organization.AutoRedirectToIdentity) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "allow_authenticate_via_warp": true, "auth_domain": "test.cloudflareaccess.com", "auto_redirect_to_identity": true, "created_at": "2014-01-01T05:20:00.12345Z", "custom_pages": { "forbidden": "699d98642c564d2e855e9661899b7252", "identity_denied": "699d98642c564d2e855e9661899b7252" }, "deny_unmatched_requests": true, "deny_unmatched_requests_exempted_zone_names": [ "example.com" ], "is_ui_read_only": true, "login_design": { "background_color": "#c5ed1b", "footer_text": "This is an example description.", "header_text": "This is an example description.", "logo_path": "https://example.com/logo.png", "text_color": "#c5ed1b" }, "mfa_config": { "allowed_authenticators": [ "totp", "biometrics", "security_key" ], "session_duration": "24h" }, "mfa_required_for_all_apps": false, "name": "Widget Corps Internal Applications", "session_duration": "24h", "ui_read_only_toggle_reason": "Temporarily turn off the UI read only lock to make a change via the UI", "updated_at": "2014-01-01T05:20:00.12345Z", "user_seat_expiration_inactive_time": "730h", "warp_auth_session_duration": "24h" } } ``` ## Update your Zero Trust organization `client.ZeroTrust.Organizations.Update(ctx, params) (*Organization, error)` **put** `/{accounts_or_zones}/{account_or_zone_id}/access/organizations` Updates the configuration for your Zero Trust organization. ### Parameters - `params OrganizationUpdateParams` - `AccountID param.Field[string]` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `ZoneID param.Field[string]` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `AllowAuthenticateViaWARP param.Field[bool]` Body param: When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AuthDomain param.Field[string]` Body param: The unique subdomain assigned to your Zero Trust organization. - `AutoRedirectToIdentity param.Field[bool]` Body param: When set to `true`, users skip the identity provider selection step during login. - `CustomPages param.Field[OrganizationUpdateParamsCustomPages]` Body param - `Forbidden string` The uid of the custom page to use when a user is denied access after failing a non-identity rule. - `IdentityDenied string` The uid of the custom page to use when a user is denied access. - `DenyUnmatchedRequests param.Field[bool]` Body param: Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames param.Field[[]string]` Body param: Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly param.Field[bool]` Body param: Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign param.Field[LoginDesign]` Body param - `MfaConfig param.Field[OrganizationUpdateParamsMfaConfig]` Body param: Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationUpdateParamsMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationUpdateParamsMfaConfigAllowedAuthenticatorTotp OrganizationUpdateParamsMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationUpdateParamsMfaConfigAllowedAuthenticatorBiometrics OrganizationUpdateParamsMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationUpdateParamsMfaConfigAllowedAuthenticatorSecurityKey OrganizationUpdateParamsMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps param.Field[bool]` Body param: Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `Name param.Field[string]` Body param: The name of your Zero Trust organization. - `SessionDuration param.Field[string]` Body param: The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason param.Field[string]` Body param: A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime param.Field[string]` Body param: The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration param.Field[string]` Body param: The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. ### Returns - `type Organization struct{…}` - `AllowAuthenticateViaWARP bool` When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AuthDomain string` The unique subdomain assigned to your Zero Trust organization. - `AutoRedirectToIdentity bool` When set to `true`, users skip the identity provider selection step during login. - `CustomPages OrganizationCustomPages` - `Forbidden string` The uid of the custom page to use when a user is denied access after failing a non-identity rule. - `IdentityDenied string` The uid of the custom page to use when a user is denied access. - `DenyUnmatchedRequests bool` Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames []string` Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly bool` Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign LoginDesign` - `BackgroundColor string` The background color on your login page. - `FooterText string` The text at the bottom of your login page. - `HeaderText string` The text at the top of your login page. - `LogoPath string` The URL of the logo on your login page. - `TextColor string` The text color on your login page. - `MfaConfig OrganizationMfaConfig` Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationMfaConfigAllowedAuthenticatorTotp OrganizationMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationMfaConfigAllowedAuthenticatorBiometrics OrganizationMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationMfaConfigAllowedAuthenticatorSecurityKey OrganizationMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps bool` Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `Name string` The name of your Zero Trust organization. - `SessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason string` A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime string` The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) organization, err := client.ZeroTrust.Organizations.Update(context.TODO(), zero_trust.OrganizationUpdateParams{ }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", organization.AutoRedirectToIdentity) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "allow_authenticate_via_warp": true, "auth_domain": "test.cloudflareaccess.com", "auto_redirect_to_identity": true, "created_at": "2014-01-01T05:20:00.12345Z", "custom_pages": { "forbidden": "699d98642c564d2e855e9661899b7252", "identity_denied": "699d98642c564d2e855e9661899b7252" }, "deny_unmatched_requests": true, "deny_unmatched_requests_exempted_zone_names": [ "example.com" ], "is_ui_read_only": true, "login_design": { "background_color": "#c5ed1b", "footer_text": "This is an example description.", "header_text": "This is an example description.", "logo_path": "https://example.com/logo.png", "text_color": "#c5ed1b" }, "mfa_config": { "allowed_authenticators": [ "totp", "biometrics", "security_key" ], "session_duration": "24h" }, "mfa_required_for_all_apps": false, "name": "Widget Corps Internal Applications", "session_duration": "24h", "ui_read_only_toggle_reason": "Temporarily turn off the UI read only lock to make a change via the UI", "updated_at": "2014-01-01T05:20:00.12345Z", "user_seat_expiration_inactive_time": "730h", "warp_auth_session_duration": "24h" } } ``` ## Revoke all Access tokens for a user `client.ZeroTrust.Organizations.RevokeUsers(ctx, params) (*OrganizationRevokeUsersResponse, error)` **post** `/{accounts_or_zones}/{account_or_zone_id}/access/organizations/revoke_user` Revokes a user's access across all applications. ### Parameters - `params OrganizationRevokeUsersParams` - `Email param.Field[string]` Body param: The email of the user to revoke. - `AccountID param.Field[string]` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `ZoneID param.Field[string]` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `QueryDevices param.Field[bool]` Query param: When set to `true`, all devices associated with the user will be revoked. - `QueryDevices param.Field[bool]` Query param: When set to `true`, all devices associated with the user will be revoked. - `UserUID param.Field[string]` Body param: The uuid of the user to revoke. - `WARPSessionReauth param.Field[bool]` Body param: When set to `true`, the user will be required to re-authenticate to WARP for all Gateway policies that enforce a WARP client session duration. When `false`, the user’s WARP session will remain active ### Returns - `type OrganizationRevokeUsersResponse bool` - `const OrganizationRevokeUsersResponseTrue OrganizationRevokeUsersResponse = true` - `const OrganizationRevokeUsersResponseFalse OrganizationRevokeUsersResponse = false` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) response, err := client.ZeroTrust.Organizations.RevokeUsers(context.TODO(), zero_trust.OrganizationRevokeUsersParams{ Email: cloudflare.F("test@example.com"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response) } ``` #### Response ```json { "result": true, "success": true } ``` ## Domain Types ### Login Design - `type LoginDesign struct{…}` - `BackgroundColor string` The background color on your login page. - `FooterText string` The text at the bottom of your login page. - `HeaderText string` The text at the top of your login page. - `LogoPath string` The URL of the logo on your login page. - `TextColor string` The text color on your login page. ### Organization - `type Organization struct{…}` - `AllowAuthenticateViaWARP bool` When set to true, users can authenticate via WARP for any application in your organization. Application settings will take precedence over this value. - `AuthDomain string` The unique subdomain assigned to your Zero Trust organization. - `AutoRedirectToIdentity bool` When set to `true`, users skip the identity provider selection step during login. - `CustomPages OrganizationCustomPages` - `Forbidden string` The uid of the custom page to use when a user is denied access after failing a non-identity rule. - `IdentityDenied string` The uid of the custom page to use when a user is denied access. - `DenyUnmatchedRequests bool` Determines whether to deny all requests to Cloudflare-protected resources that lack an associated Access application. If enabled, you must explicitly configure an Access application and policy to allow traffic to your Cloudflare-protected resources. For domains you want to be public across all subdomains, add the domain to the `deny_unmatched_requests_exempted_zone_names` array. - `DenyUnmatchedRequestsExemptedZoneNames []string` Contains zone names to exempt from the `deny_unmatched_requests` feature. Requests to a subdomain in an exempted zone will block unauthenticated traffic by default if there is a configured Access application and policy that matches the request. - `IsUIReadOnly bool` Lock all settings as Read-Only in the Dashboard, regardless of user permission. Updates may only be made via the API or Terraform for this account when enabled. - `LoginDesign LoginDesign` - `BackgroundColor string` The background color on your login page. - `FooterText string` The text at the bottom of your login page. - `HeaderText string` The text at the top of your login page. - `LogoPath string` The URL of the logo on your login page. - `TextColor string` The text color on your login page. - `MfaConfig OrganizationMfaConfig` Configures multi-factor authentication (MFA) settings for an organization. - `AllowedAuthenticators []OrganizationMfaConfigAllowedAuthenticator` Lists the MFA methods that users can authenticate with. - `const OrganizationMfaConfigAllowedAuthenticatorTotp OrganizationMfaConfigAllowedAuthenticator = "totp"` - `const OrganizationMfaConfigAllowedAuthenticatorBiometrics OrganizationMfaConfigAllowedAuthenticator = "biometrics"` - `const OrganizationMfaConfigAllowedAuthenticatorSecurityKey OrganizationMfaConfigAllowedAuthenticator = "security_key"` - `SessionDuration string` Defines the duration of an MFA session. Must be in minutes (m) or hours (h). Minimum: 0m. Maximum: 720h (30 days). Examples:`5m` or `24h`. - `MfaRequiredForAllApps bool` Determines whether global MFA settings apply to applications by default. The organization must have MFA enabled with at least one authentication method and a session duration configured. - `Name string` The name of your Zero Trust organization. - `SessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. - `UIReadOnlyToggleReason string` A description of the reason why the UI read only field is being toggled. - `UserSeatExpirationInactiveTime string` The amount of time a user seat is inactive before it expires. When the user seat exceeds the set time of inactivity, the user is removed as an active seat and no longer counts against your Teams seat count. Minimum value for this setting is 1 month (730h). Must be in the format `300ms` or `2h45m`. Valid time units are: `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. - `WARPAuthSessionDuration string` The amount of time that tokens issued for applications will be valid. Must be in the format `30m` or `2h45m`. Valid time units are: m, h. # DOH ## Get your Zero Trust organization DoH settings `client.ZeroTrust.Organizations.DOH.Get(ctx, query) (*OrganizationDOHGetResponse, error)` **get** `/accounts/{account_id}/access/organizations/doh` Returns the DoH settings for your Zero Trust organization. ### Parameters - `query OrganizationDOHGetParams` - `AccountID param.Field[string]` Identifier. ### Returns - `type OrganizationDOHGetResponse struct{…}` - `ID string` The ID of the service token. - `ClientID string` The Client ID for the service token. Access will check for this value in the `CF-Access-Client-ID` request header. - `DOHJWTDuration string` The duration the DoH JWT is valid for. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. Note that the maximum duration for this setting is the same as the key rotation period on the account. - `Duration string` The duration for how long the service token will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. The default is 1 year in hours (8760h). - `ExpiresAt Time` - `Name string` The name of the service token. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) doh, err := client.ZeroTrust.Organizations.DOH.Get(context.TODO(), zero_trust.OrganizationDOHGetParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", doh.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "client_id": "88bf3b6d86161464f6509f7219099e57.access.example.com", "created_at": "2014-01-01T05:20:00.12345Z", "doh_jwt_duration": "800h", "duration": "60m", "expires_at": "2014-01-01T05:20:00.12345Z", "last_seen_at": "2014-01-01T05:20:00.12345Z", "name": "CI/CD token", "updated_at": "2014-01-01T05:20:00.12345Z" } } ``` ## Update your Zero Trust organization DoH settings `client.ZeroTrust.Organizations.DOH.Update(ctx, params) (*OrganizationDOHUpdateResponse, error)` **put** `/accounts/{account_id}/access/organizations/doh` Updates the DoH settings for your Zero Trust organization. ### Parameters - `params OrganizationDOHUpdateParams` - `AccountID param.Field[string]` Path param: Identifier. - `DOHJWTDuration param.Field[string]` Body param: The duration the DoH JWT is valid for. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. Note that the maximum duration for this setting is the same as the key rotation period on the account. Default expiration is 24h - `ServiceTokenID param.Field[string]` Body param: The uuid of the service token you want to use for DoH authentication ### Returns - `type OrganizationDOHUpdateResponse struct{…}` - `ID string` The ID of the service token. - `ClientID string` The Client ID for the service token. Access will check for this value in the `CF-Access-Client-ID` request header. - `DOHJWTDuration string` The duration the DoH JWT is valid for. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. Note that the maximum duration for this setting is the same as the key rotation period on the account. Default expiration is 24h - `Duration string` The duration for how long the service token will be valid. Must be in the format `300ms` or `2h45m`. Valid time units are: ns, us (or µs), ms, s, m, h. The default is 1 year in hours (8760h). - `ExpiresAt Time` - `Name string` The name of the service token. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/zero_trust" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) doh, err := client.ZeroTrust.Organizations.DOH.Update(context.TODO(), zero_trust.OrganizationDOHUpdateParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", doh.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "client_id": "88bf3b6d86161464f6509f7219099e57.access.example.com", "created_at": "2014-01-01T05:20:00.12345Z", "doh_jwt_duration": "800h", "duration": "60m", "expires_at": "2014-01-01T05:20:00.12345Z", "last_seen_at": "2014-01-01T05:20:00.12345Z", "name": "CI/CD token", "updated_at": "2014-01-01T05:20:00.12345Z" } } ```